///////////////////////////////////////////////////////////////////////////////
//Design and implementation by Medicineman Media Solutions.                  //
//Info at www.medicineman.com                                                //
///////////////////////////////////////////////////////////////////////////////

g_NumberOfAnimationsRunning = 0;


function CAnimation(duration)
{
	this.interval = 10;

	this.elements = new Array();
	this.elementCount = 0;
	this.intervalID = 0;
	this.duration = duration;
	this.currentFrame = 0


	this.frameCount = this.duration / this.interval

	this.runForward = CAnimation_RunForward;
	this.runBackward = CAnimation_RunBackward;
	this.goToLastFrame = CAnimation_GoToLastFrame;
	this.addLayer = CAnimation_AddLayer;
	this.animate = CAnimation_Animate;
	this.start = CAnimation_Start;
	this.stop = CAnimation_Stop;
}

function CAnimation_GoToLastFrame()
{
	for(i=0; i<this.elementCount; i++)
	{
		this.elements[i].moveToEndLocation();
	}
}


function CAnimation_RunForward(callBackFunction)
{
	this.start(1, callBackFunction);
}

function CAnimation_RunBackward(callBackFunction)
{
	this.start(-1, callBackFunction);
}

function CAnimation_AddLayer(layer, startX, startY, direction, distance)
{
	if (startX == null)
	{
		startX = layer.left;
	}

	if (startY == null)
	{
		startY = layer.top;
	}
	
	newElement = new CAnimationElement(layer, startX, startY, direction, distance);
	this.elements[this.elementCount] = newElement;	
	this.elementCount ++;
}

function CAnimation_Start(direction, callBackFunction)
{
	this.currentFrame = 0;
	this.direction= direction;
	g_NumberOfAnimationsRunning ++;

	
	this.onFinishCallBack = callBackFunction;

	if (this.direction==-1)
	{
		this.goToLastFrame();
	}
	
	this.intervalID = setInterval(mapToObjectMethod(this, "animate") ,1);
}



function CAnimation_Animate()
{

	this.currentFrame ++
	for(i=0; i<this.elementCount; i++)
	{
		
		deltaX = 0
		deltaY = 0
		
		switch (this.elements[i].direction)
		{
			case "x":
				deltaX = this.elements[i].distance/this.frameCount;
				break;

			case "-x":
				deltaX = -1 * (this.elements[i].distance/this.frameCount);
				break;

			case "y":
				deltaY = this.elements[i].distance/this.frameCount;
				break;

			case "-y":
				deltaY = -1 * (this.elements[i].distance/this.frameCount);
				break;
		}	

		this.elements[i].moveBy(deltaX * this.direction, deltaY * this.direction);
	}
	if (this.currentFrame==this.frameCount)
	{
		this.stop()
	}
}

function CAnimation_Stop()
{
	g_NumberOfAnimationsRunning --;
	clearInterval(this.intervalID);
	if (this.onFinishCallBack!=null)
	{
		this.onFinishCallBack();
	}
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
function CAnimationElement(layer, startX, startY, direction, distance)
{
	this.layer = layer;
	this.startX = startX;
	this.startY = startY;
	this.direction = direction;
	this.distance = distance;
	this.currentY = startY;
	this.currentX = startX;


	this.moveBy = CAnimationElement_MoveBy;
	this.moveToEndLocation = CAnimationElement_MoveToEndLocation;
}

function CAnimationElement_MoveBy(deltaX,deltaY)
{
	this.currentX = this.currentX + deltaX;
	this.currentY = this.currentY + deltaY;
	this.layer.moveTo(this.currentX, this.currentY);
}

function CAnimationElement_MoveToEndLocation()
{
	if (this.direction=="x")
	{
		this.layer.moveTo(this.startX + this.distance, this.startY);
	}
	if (this.direction=="-x")
	{
		this.layer.moveTo(this.startX - this.distance, this.startY);
	}
	if (this.direction=="y")
	{
		this.layer.moveTo(this.startX, this.startY + this.distance);
	}
	if (this.direction=="-y")
	{
		this.layer.moveTo(this.startX, this.startY - this.distance);
	}
	this.currentY = this.layer.top;
	this.currentX = this.layer.left;

}

