///////////////////////////////////////////////////////////////////////////////
//Design and implementation by Medicineman Media Solutions.                  //
//Info at www.medicineman.com                                                //
///////////////////////////////////////////////////////////////////////////////



function CButton(layer, buttonType, onClick)
{

	//Data
	this.numberOfStates = 3;
	this.buttonType = buttonType;
	this.layer = layer;
	this.isSelected = false;
	this.value= null;
	this.enabled = true;
	this.normalImage = null;
	this.rolloverImage = null;
	this.selectedImage = null;
	this.captionStyleName = null;
	this.currentState = "Normal";
	this.isRepeatingButton = false;
	this.repeatIntervalID = null;
	this.repeatDelay = 100;
	this.fontTag = null;

	if (onClick != "undefined") 
	{
		this.onClick = onClick;
	}
	else
	{
		this.onClick = null;
	}
	this.onRollOver = null;	
	this.onRollOut = null;	


	//Methods
	this.setButtonState= CButton_SetButtonState;
	this.onMouseDown = CButton_OnMouseDown; 
	this.onMouseOver = CButton_OnMouseOver; 
	this.onMouseOut =  CButton_OnMouseOut; 
	this.onMouseUp =  CButton_OnMouseUp; 

	this.deselect = CButton_Deselect;
	this.select = CButton_Select;
	this.show = CButton_Show;
	this.hide = CButton_Hide;
	this.enable = CButton_Enable;
	this.disable = CButton_Disable;
	this.setCaption = CButton_SetCaption;
	this.setImages = CButton_SetImages;
	this.setBaseImage = CButton_SetBaseImage;
	this.setButtonStateForImageButton = CButton_SetButtonStateForImageButton;
	this.setButtonStateForLayerButton = CButton_SetButtonStateForLayerButton;
	this.cancelRepeat = CButton_CancelRepeat;
	this.startRepeat = CButton_StartRepeat;



	//Event Mapping
	layer.document.captureEvents(Event.MOUSEDOWN|Event.MOUSEUP|Event.MOUSEOVER|Event.MOUSEOUT);	
	layer.document.onMouseDown = mapToObjectMethod(this, "onMouseDown");
	layer.document.onMouseOut = mapToObjectMethod(this,"onMouseOut");
	layer.document.onMouseOver = mapToObjectMethod(this, "onMouseOver");
	layer.document.onMouseUp = mapToObjectMethod(this, "onMouseUp");


	//Intilialize
	if(this.buttonType=="image") this.setBaseImage(this.layer.document.images[0].src);

}


function CButton_CancelRepeat()
{
	if (this.repeatIntervalID!=null)
	{
		clearInterval(this.repeatIntervalID)
		this.repeatIntervalID=null;
	}

}

function CButton_StartRepeat()
{
	this.repeatIntervalID = setInterval(mapToObjectMethod(this,"onClick"), this.repeatDelay);
}


function CButton_SetBaseImage(imageBaseURL)
{
	imageBase = imageBaseURL.substring(0,imageBaseURL.length - 4)
	imageSuffix = imageBaseURL.substring(imageBaseURL.length - 4,imageBaseURL.length)
	this.setImages(imageBase + imageSuffix, imageBase +  "_r" + imageSuffix, imageBase + "_s" + imageSuffix);
}

function CButton_SetImages(normalImage, rolloverImage, selectedImage)
{
	this.normalImage = normalImage;
	this.rolloverImage = rolloverImage;
	this.selectedImage = selectedImage;
	
	if (this.buttonType == "layer")
	{
		this.layer.document.layers["Normal"].document.images[0].src = normalImage
		this.layer.document.layers["Rollover"].document.images[0].src = rolloverImage
		this.layer.document.layers["Selected"].document.images[0].src = selectedImage
	}
	else
	{
		switch(this.currentState)
		{
			case "Normal":
				this.layer.document.images[0].src = normalImage;
				break;
	
			case "Rollover":
				this.layer.document.images[0].src = rolloverImage;
				break;

			case "Selected":
				this.layer.document.images[0].src = selectedImage;
				break;
		}
	}
}


function CButton_SetCaption(caption)
{
	captionLayer = this.layer.document.layers["Caption"];
	
	//if (g_DisableDocumentWrite==false) 
	//{
		captionLayer.document.open();
		if (this.fontTag!=null)
		{	
			captionLayer.document.writeln(this.fontTag + caption + "</FONT>")
		}
		else
		{
			captionLayer.document.write(caption);
		}
		captionLayer.document.close();	
	//}
}

function CButton_Enable()
{
	this.enabled = true;
}

function CButton_Disable()
{
	this.enabled = false;
}

function CButton_Show()
{
	this.layer.visibility="inherit";
}

function CButton_Hide()
{
	this.layer.visibility= "hide";
}


function CButton_Deselect()
{
	this.setButtonState("Normal");
}

function CButton_Select()
{
	this.setButtonState("Selected");
}


function CButton_OnMouseDown(e)
{
	if (this.enabled==true)
	{
		if (this.currentState=="Selected")
		{
			//this.deselect();
			//this.onClickHandler();
		}
		else
		{
			if (this.onClick != null) this.onClick();
			if (this.isRepeatingButton==true)
			{
				this.startRepeat();
			}


		}
	}
	return false;
}

function CButton_OnMouseUp(e)
{
	this.cancelRepeat();
}

function CButton_OnMouseOver(e)
{
	if(this.enabled == true)
	{
		if (this.currentState == "Normal")
		{	
			this.setButtonState("Rollover");

			if (this.onRollOver!=null) this.onRollOver();
		}
	}
	return false;

}
function CButton_OnMouseOut(e)
{
	if(this.enabled == true)
	{
		if (this.currentState == "Rollover")
		{	
			this.setButtonState("Normal");
			if (this.onRollOut!=null) this.onRollOut();

		}
	}
	this.cancelRepeat();
	return false;

}

function CButton_SetButtonState(state)
{

	this.currentState = state
	
	if (this.numberOfStates > 1)
	{
		if (this.buttonType == "layer")
		{
			this.setButtonStateForLayerButton(state);
		}
		else
		{
			this.setButtonStateForImageButton(state);
		}
	}
}

function CButton_SetButtonStateForLayerButton(state)
{
	this.currentState = state;
	switch(state)
	{
		case "Normal":
			this.layer.document.layers["Normal"].visibility = "inherit";
			this.layer.document.layers["Rollover"].visibility = "hide";
			this.layer.document.layers["Selected"].visibility = "hide";
			break;
							
		case "Rollover":
			this.layer.document.layers["Rollover"].visibility = "inherit";
			this.layer.document.layers["Normal"].visibility = "hide";
			this.layer.document.layers["Selected"].visibility = "hide";
			break;

		case "Selected":
			this.layer.document.layers["Selected"].visibility = "inherit";
			this.layer.document.layers["Normal"].visibility = "hide";
			this.layer.document.layers["Rollover"].visibility = "hide";
			break;
	}
			
	this.layer.clip.left = this.layer.document.layers[state].left;
	this.layer.clip.top  = this.layer.document.layers[state].top;
	this.layer.clip.width = this.layer.document.layers[state].clip.width;
	this.layer.clip.height  = this.layer.document.layers[state].clip.height;
}

function CButton_SetButtonStateForImageButton(state)
{
	switch(state)
	{
		case "Normal":
			this.layer.document.images[0].src = this.normalImage;
			break;
							
		case "Rollover":
			this.layer.document.images[0].src = this.rolloverImage;
			break;

		case "Selected":
			this.layer.document.images[0].src = this.selectedImage;
			break;
	}
}
