///////////////////////////////////////////////////////////////////////////////
//Design and implementation by Medicineman Media Solutions.                  //
//Info at www.medicineman.com                                                //
///////////////////////////////////////////////////////////////////////////////


function CDrawer(caption, top, handleImage, contentImage)
{
	//data
	this.contentLayer = new Layer(500);
	this.caption = caption;
	this.icons = new Array();
	this.isOpen = false;
	this.iconWidth = 70;
	this.iconHeight= 80;
	this.isAnimating = false

	this.animation = new CAnimation(100);
	this.iconRow = 0;
	this.iconColumn = 0;

	//methods
	this.addIcon = CDrawer_AddIcon;
	this.onHandleClick = CDrawer_OnHandleClick;
	this.onIconClick = CDrawer_OnIconClick;
	this.open = CDrawer_Open;
	this.close = CDrawer_Close;
	this.clearAnimationFlag = CDrawer_ClearAnimationFlag;
	
	//init handle
	this.handleLayer = new Layer(800);
	
	this.handleLayer.document.open()
	this.handleLayer.document.write("<IMG SRC='" + handleImage + "'>");
	this.handleLayer.document.close()
	
	this.handleHeight = this.handleLayer.document.images[0].height;
	this.handleWidth = this.handleLayer.document.images[0].width;

	this.handleLayer.left = window.innerWidth - this.handleWidth + 4;
	this.handleLayer.top = top;
	this.handleLayer.clip.height = this.handleHeight;
	this.handleLayer.clip.width = this.handleWidth;



	captionLayer = new Layer(this.handleWidth,this.handleLayer);
	captionLayer.top = 0;
	captionLayer.left = 0;
	captionLayer.clip.height = this.handleHeight;
	captionLayer.clip.width = this.handleWidth;
	
	captionLayer.document.open()
	captionLayer.document.write(caption);
	captionLayer.document.close()
	captionLayer.visibility = "inherit";

	

	this.handleButton = new CButton(this.handleLayer, "image", mapToObjectMethod(this, "onHandleClick"));
	this.handleLayer.visibility = "inherit";


	
	//init contents
	this.contentLayer= new Layer(800);
	this.contentLayer.document.open()
	this.contentLayer.document.write("<IMG SRC='" + contentImage + "'>");
	this.contentLayer.document.close()
	this.contentWidth = this.contentLayer.document.images[0].width;
	this.contentHeight = this.contentLayer.document.images[0].width;
	this.contentLayer.left = window.innerWidth + 4;
	this.contentLayer.top = top;
	this.contentLayer.clip.height = this.contentHeight;
	this.contentLayer.clip.width = this.contentWidth;
	this.contentLayer.visibility = "inherit";
			
	//init animation
	this.animation.addLayer(this.handleLayer,null,null, "-x", this.contentWidth);
	this.animation.addLayer(this.contentLayer,null,null, "-x", this.contentWidth);

}

function CDrawer_ClearAnimationFlag()
{
	this.isAnimating = false
}




function CDrawer_OnIconClick(iconIndex)
{

	window.open(this.icons[iconIndex].url,"demo");
	return false;
}

function CDrawer_OnHandleClick()
{
	if (this.isOpen==true)
	{
		this.close()
	}
	else
	{
		this.open();
	}

}

function CDrawer_Open()
{
	if (this.isAnimating == false)
	{
		this.handleLayer.zIndex = 0;
		this.contentLayer.zIndex = 0;
		this.isAnimating=true;
		this.animation.runForward(mapToObjectMethod(this, "clearAnimationFlag"))
		this.isOpen = true;
	}
}

function CDrawer_Close()
{
	if (this.isAnimating == false)
	{
		this.isAnimating=true;
		this.animation.runBackward(mapToObjectMethod(this, "clearAnimationFlag"));
		this.isOpen = false;
	}
}

function CDrawer_AddIcon(label, url, image)
{
	newIcon = new CDrawerIcon(label, url);
	iconIndex = this.icons.length 
	this.icons[iconIndex] = newIcon;

	newIconLayer = new Layer(this.iconWidth, this.contentLayer);
	newIconLayer.document.open();
	newIconLayer.document.write("<center>");
	newIconLayer.document.write("<a href=''>");
	newIconLayer.document.write("<img border=0 src='" + image + "'>");
	newIconLayer.document.write("<br>");
	newIconLayer.document.write("<FONT SIZE=1 FACE=arial,helvetica><B>" + label + "</B></FONT>");
	newIconLayer.document.write("</a>");
	newIconLayer.document.write("</center>");
	newIconLayer.document.close();

	newIconLayer.top = (this.iconRow * this.iconHeight) + 10;
	newIconLayer.left = (this.iconColumn * this.iconWidth) + 10;
	
	this.iconColumn++;

	if (((this.iconColumn +1)* this.iconWidth) > this.contentWidth)
	{
		this.iconColumn = 0;
		this.iconRow++;
	}

	newIconLayer.visibility = "inherit";
	newIconLayer.document.links[0].onclick = mapToObjectMethod(this,"onIconClick", iconIndex);

	
}



//CDrawerIcon
function CDrawerIcon(label, url, image)
{
	this.label = label;
	this.url = url;
}