///////////////////////////////////////////////////////////////////////////////
//Design and implementation by Medicineman Media Solutions.                  //
//Info at www.medicineman.com                                                //
///////////////////////////////////////////////////////////////////////////////


function CSectionManager(tabImage, contentLeft, contentTop, contentWidth, contentHeight)
{
	//data
	this.sections = new Array();	
	this.buttons = new Array();
	this.tabImage = tabImage;
	this.sectionIsLoading = false;
        this.tabWidth = 0;

	//methods
	this.addSection = CSectionManager_AddSection;
	this.onSectionClick = CSectionManager_OnSectionClick;
	this.gotoSection = CSectionManager_GotoSection;
	this.clearSectionLoadingFlag = CSectionManager_ClearSectionLoadingFlag; 

	//content layer	
	this.contentLayer = new Layer(contentWidth);
	this.contentLayer.top = contentTop;
	this.contentLayer.left = contentLeft;
	this.contentLayer.clip.height = contentHeight;
	this.contentLayer.clip.width = contentWidth;
	this.contentLayer.visibility = "inherit";
}

function CSectionManager_ClearSectionLoadingFlag()
{
	this.sectionIsLoading = false;
}


function CSectionManager_AddSection(label, url, tabLeft, tabTop)
{
	
	sectionIndex = this.sections.length;
	this.sections[sectionIndex] = url;
	
	tabLayer= new Layer(800);
	
	tabLayer.document.open()
	tabLayer.document.write("<IMG SRC='" + this.tabImage + "'>");
	tabLayer.document.close()
	
	this.tabHeight = tabLayer.document.images[0].height;
	this.tabWidth = tabLayer.document.images[0].width;
	
	tabLayer.left = tabLeft;
	tabLayer.top = tabTop;
	tabLayer.clip.height = this.tabHeight;
	tabLayer.clip.width = this.tabWidth;

	captionLayer = new Layer(this.tabWidth,tabLayer);
	captionLayer.top = 0;
	captionLayer.left = 0;
	captionLayer.clip.height = this.tabHeight;
	captionLayer.clip.width = this.tabWidth;


	captionLayer.document.open()
	captionLayer.document.write(label);
	captionLayer.document.close()
	captionLayer.visibility = "inherit";


	this.buttons[sectionIndex] = new CButton(tabLayer, "image", mapToObjectMethod(this, "onSectionClick", sectionIndex));

	tabLayer.visibility = "inherit";
}

function CSectionManager_OnSectionClick(sectionIndex)
{

	this.gotoSection(sectionIndex);
}

function CSectionManager_GotoSection(sectionIndex)
{
	
	if (this.sectionIsLoading==false)
	{
	
		for(i=0;i<=this.buttons.length-1;i++)
		{
			if(i==sectionIndex) 
				this.buttons[i].select();
			else
				this.buttons[i].deselect();
			
		}
		if (this.sections[sectionIndex]!="")
		{
			this.sectionIsLoading=true
			this.contentLayer.onLoad = mapToObjectMethod(this, "clearSectionLoadingFlag");
			this.contentLayer.src = this.sections[sectionIndex];
			this.contentLayer.visibility = "inherit"
		}
		else
		{
			this.contentLayer.visibility = "hide"
		}
	}
}

